function PWRLoadOptionsPanel()
	local scrollmax = 155
	
	PWROptionsPanel = CreateFrame("ScrollFrame", nil, UIParent);
	PWROptionsPanel.name = PWRAddonTitle
	PWROptionsPanel:EnableMouseWheel(true)
	PWROptionsPanel:SetScript("OnMouseWheel", function (self, delta) 
		local current = PWROptionsPanel.Scrollbar:GetValue()
		if IsShiftKeyDown() and (delta > 0) then
			PWROptionsPanel.Scrollbar:SetValue(0)
		elseif IsShiftKeyDown() and (delta < 0) then
			PWROptionsPanel.Scrollbar:SetValue(scrollmax)
		elseif (delta < 0) and (current < scrollmax) then
			PWROptionsPanel.Scrollbar:SetValue(current + 20)
		elseif (delta > 0) and (current > 1) then
			PWROptionsPanel.Scrollbar:SetValue(current - 20)
		end
	end)
	
	PWROptionsPanel.Scrollbar = CreateFrame("Slider", nil, PWROptionsPanel, "UIPanelScrollBarTemplate") 
	PWROptionsPanel.Scrollbar:SetPoint("TOPLEFT", PWROptionsPanel, "TOPRIGHT", -20, -20) 
	PWROptionsPanel.Scrollbar:SetPoint("BOTTOMLEFT", PWROptionsPanel, "BOTTOMRIGHT", -20, 20)
	PWROptionsPanel.Scrollbar:SetMinMaxValues(1, scrollmax)
	PWROptionsPanel.Scrollbar:EnableMouseWheel(true)
	PWROptionsPanel.Scrollbar:SetValueStep(1) 
	PWROptionsPanel.Scrollbar.scrollStep = 1
	PWROptionsPanel.Scrollbar:SetValue(0) 
	PWROptionsPanel.Scrollbar:SetWidth(16) 
	PWROptionsPanel.Scrollbar:SetScript("OnValueChanged", function (self, value) 
		self:GetParent():SetVerticalScroll(value) 
	end)
	
	--content frame 
	PWROptionsPanel.Content = CreateFrame("Frame", nil, PWROptionsPanel) 
	PWROptionsPanel:SetScrollChild(PWROptionsPanel.Content)
	-- DONE adding scrollable frame.
	
	PWROptionsPanel.Content.NameLabel = PWROptionsPanel.Content:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	PWROptionsPanel.Content.NameLabel:SetText(PWRAddonTitle)
	PWROptionsPanel.Content.NameLabel:SetPoint("TOPLEFT", 15, -15)

	PWROptionsPanel.Content.DescLabel = PWROptionsPanel.Content:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	PWROptionsPanel.Content.DescLabel:SetText(PWRAddonNotes)
	PWROptionsPanel.Content.DescLabel:SetPoint("TOPLEFT", PWROptionsPanel.Content.NameLabel, "BOTTOMLEFT", 0, -8)

	PWROptionsPanel.Content.IsLocked = CreateFrame("CheckButton", "IsLocked", PWROptionsPanel.Content, "UICheckButtonTemplate")
	PWROptionsPanel.Content.IsLocked:SetPoint("TOPLEFT", 18, -55)
	IsLockedText:SetText("Locked In Place")
	PWROptionsPanel.Content.IsLocked:SetScript("OnClick", function(self, button, down)
		PerSettings.IsLocked = PWROptionsPanel.Content.IsLocked:GetChecked()
		mainFrame:SetMovable(not PerSettings.IsLocked)
		mainFrame:EnableMouse(not PerSettings.IsLocked)
	end)
	PWROptionsPanel.Content.IsLocked:SetChecked(PerSettings.IsLocked)
	
	local height = 95
	local specStep = 145
	PWROptionsPanel.Content.SpecsInfo = {}
	for specID = 1, GetNumSpecializations() do
		PWROptionsPanel.Content.SpecsInfo[specID] = {}
		local specInfo = PWROptionsPanel.Content.SpecsInfo[specID]
		local specSettings = PerSettings.SpecsInfo[specID]
		local id, name, description, icon, background, role = GetSpecializationInfo(specID)
		
		specInfo.NameLabel = PWROptionsPanel.Content:CreateFontString("NameLabel" .. specID, "ARTWORK", "GameFontHighlight")
		specInfo.NameLabel:SetText(name)
		-- If it's not the first
		if (PWROptionsPanel.Content.SpecsInfo[specID - 1]) then
			height = height + specStep
			specInfo.NameLabel:SetPoint("TOPLEFT", PWROptionsPanel.Content.SpecsInfo[specID - 1].NameLabel, "BOTTOMLEFT", 0, -specStep)
		else -- otherwise
			specInfo.NameLabel:SetPoint("TOPLEFT", 45, -95)
		end
		local currLabel = specInfo.NameLabel
		
		specInfo.Icon = PWROptionsPanel.Content:CreateTexture(nil, "BACKGROUND")
		specInfo.Icon:SetTexture(icon)
		specInfo.Icon:SetSize(24, 24)
		specInfo.Icon:SetPoint("LEFT", currLabel, "LEFT", -32, 0)
		
		specInfo.ShowSpec = CreateFrame("CheckButton", "ShowSpec" .. specID, PWROptionsPanel.Content, "UICheckButtonTemplate")
		specInfo.ShowSpec:SetPoint("BOTTOMLEFT", currLabel, "BOTTOMLEFT", -20, -40)
		_G[specInfo.ShowSpec:GetName() .. "Text"]:SetText("Enabled")
		specInfo.ShowSpec:SetScript("OnClick", function(self, button, down)
			specSettings.ShowSpec = specInfo.ShowSpec:GetChecked()
			if (GetSpecialization() == specID) then
				if (specSettings.ShowSpec and not specSettings.IsOnlyInCombat) then
					mainFrame:Show()
				else
					mainFrame:Hide()
				end
			end
		end)
		specInfo.ShowSpec:SetChecked(specSettings.ShowSpec)
		
		specInfo.IsOnlyInCombat = CreateFrame("CheckButton", "IsOnlyInCombat" .. specID, PWROptionsPanel.Content, "UICheckButtonTemplate")
		specInfo.IsOnlyInCombat:SetPoint("BOTTOMLEFT", specInfo.ShowSpec, "BOTTOMLEFT", 0, -30)
		_G[specInfo.IsOnlyInCombat:GetName() .. "Text"]:SetText("Only In Combat")
		specInfo.IsOnlyInCombat:SetScript("OnClick", function(self, button, down)
			specSettings.IsOnlyInCombat = specInfo.IsOnlyInCombat:GetChecked()
			if (GetSpecialization() == specID) then
				if (specSettings.IsOnlyInCombat) then
					mainFrame:Hide()
				elseif (specSettings.ShowSpec) then
					mainFrame:Show()
				end
			end
		end)
		specInfo.IsOnlyInCombat:SetChecked(specSettings.IsOnlyInCombat)

		specInfo.ShowCurrent = CreateFrame("CheckButton", "ShowCurrent" .. specID, PWROptionsPanel.Content, "UICheckButtonTemplate")
		specInfo.ShowCurrent:SetPoint("LEFT", specInfo.ShowSpec, "RIGHT", 130, 0)
		_G[specInfo.ShowCurrent:GetName() .. "Text"]:SetText("Show Current Power")
		specInfo.ShowCurrent:SetScript("OnClick", function(self, button, down)
			specSettings.ShowCurrent = specInfo.ShowCurrent:GetChecked()
			PWRSetVisible(specInfo.CurrentAlign, specSettings.ShowCurrent)
			if (GetSpecialization() == specID) then
				if (specSettings.ShowCurrent) then
					mainFrame.Current:Show()
				else
					mainFrame.Current:Hide()
				end
			end
		end)
		specInfo.ShowCurrent:SetChecked(specSettings.ShowCurrent)
		
		specInfo.ShowPercent = CreateFrame("CheckButton", "ShowPercent" .. specID, PWROptionsPanel.Content, "UICheckButtonTemplate")
		specInfo.ShowPercent:SetPoint("BOTTOMLEFT", specInfo.ShowCurrent, "BOTTOMLEFT", 0, -30)
		_G[specInfo.ShowPercent:GetName() .. "Text"]:SetText("Show Percentage")
		specInfo.ShowPercent:SetScript("OnClick", function(self, button, down)
			specSettings.ShowPercent = specInfo.ShowPercent:GetChecked()
			PWRSetVisible(specInfo.PercentAlign, specSettings.ShowPercent)
			if (GetSpecialization() == specID) then
				if (specSettings.ShowPercent) then
					mainFrame.Percent:Show()
				else
					mainFrame.Percent:Hide()
				end
			end
		end)
		specInfo.ShowPercent:SetChecked(specSettings.ShowPercent)
		
		specInfo.ShowMax = CreateFrame("CheckButton", "ShowMax" .. specID, PWROptionsPanel.Content, "UICheckButtonTemplate")
		specInfo.ShowMax:SetPoint("BOTTOMLEFT", specInfo.ShowPercent, "BOTTOMLEFT", 0, -30)
		_G[specInfo.ShowMax:GetName() .. "Text"]:SetText("Show Maximum Power")
		specInfo.ShowMax:SetScript("OnClick", function(self, button, down)
			specSettings.ShowMax = specInfo.ShowMax:GetChecked()
			PWRSetVisible(specInfo.MaxAlign, specSettings.ShowMax)
			if (GetSpecialization() == specID) then
				if (specSettings.ShowMax) then
					mainFrame.Max:Show()
				else
					mainFrame.Max:Hide()
				end
			end
		end)
		specInfo.ShowMax:SetChecked(specSettings.ShowMax)
		
		specInfo.UseCustomColor = CreateFrame("CheckButton", "UseCustomColor" .. specID, PWROptionsPanel.Content, "UICheckButtonTemplate")
		specInfo.UseCustomColor:SetPoint("LEFT", specInfo.ShowCurrent, "RIGHT", 215, 0) 
		_G[specInfo.UseCustomColor:GetName() .. "Text"]:SetText("Custom Bar Color")
		specInfo.UseCustomColor:SetScript("OnClick", function(self, button, down)
			specSettings.UseCustomColor = specInfo.UseCustomColor:GetChecked()
			specInfo.CustomColor.Texture:SetColorTexture(specSettings.CustomColor.r, specSettings.CustomColor.g, specSettings.CustomColor.b, specSettings.UseCustomColor and 1 or 0.1)
			if (GetSpecialization() == specID) then
				PWRRefreshPowerColor(specID)
			end
		end)
		specInfo.UseCustomColor:SetChecked(specSettings.UseCustomColor)
		
		specInfo.CustomColor = CreateFrame("Frame", nil, PWROptionsPanel.Content)
		specInfo.CustomColor:SetSize(14, 14)
		specInfo.CustomColor:SetPoint("LEFT", _G[specInfo.UseCustomColor:GetName() .. "Text"], "RIGHT", 15, 0) 
		specInfo.CustomColor.Texture = specInfo.CustomColor:CreateTexture(nil, "BACKGROUND")
		specInfo.CustomColor.Texture:SetAllPoints(true)
		specInfo.CustomColor.Texture:SetColorTexture(specSettings.CustomColor.r, specSettings.CustomColor.g, specSettings.CustomColor.b, specSettings.UseCustomColor and 1 or 0.1)
		specInfo.CustomColor:SetScript("OnMouseDown", function(self, button)
			if (button == "LeftButton" and specInfo.UseCustomColor:GetChecked()) then
				local r, g, b
				PWRShowColorPicker(specSettings.CustomColor, function(restore)
					if (not restore) then
						r, g, b = ColorPickerFrame:GetColorRGB()
					else
						r, g, b = unpack(restore)
					end
					specSettings.CustomColor.r, specSettings.CustomColor.g, specSettings.CustomColor.b = r, g, b
					self.Texture:SetColorTexture(r, g, b, 1)
					PWRRefreshPowerColor(specID)
				end)
			end
		end)
		
		specInfo.Length = CreateFrame("Slider", "Length" .. specID, PWROptionsPanel.Content, "OptionsSliderTemplate")
		specInfo.Length:SetOrientation("HORIZONTAL")
		specInfo.Length:SetPoint("LEFT", specInfo.ShowMax, "RIGHT", 215, -20) 
		specInfo.Length:SetSize(140, 16) 
		specInfo.Length:SetMinMaxValues(120, 300)
		specInfo.Length:SetValueStep(1)
		specInfo.Length:SetObeyStepOnDrag(true)
		specInfo.Length:SetValue(specSettings.Length)
		_G[specInfo.Length:GetName() .. "Low"]:SetText("120")
		_G[specInfo.Length:GetName() .. "High"]:SetText("300")
		_G[specInfo.Length:GetName() .. "Text"]:SetText("Length: " .. specInfo.Length:GetValue())
		specInfo.Length:SetScript("OnValueChanged", function (self, value) 
			value = PWRFloorIfNotWhole(value)
			specSettings.Length = value
			_G[specInfo.Length:GetName() .. "Text"]:SetText("Length: " .. value)
			specInfo.LengthEditBox:SetNumber(value)
			if (GetSpecialization() == specID) then
				PWRRefreshLength(specID)
			end
		end)
		
		specInfo.LengthEditBox = CreateFrame("EditBox", "LengthEditBox" .. specID, specInfo.Length, "InputBoxTemplate")
		specInfo.LengthEditBox:SetPoint("CENTER", 0, -15)
		specInfo.LengthEditBox:SetNumeric(true)
		specInfo.LengthEditBox:SetAutoFocus(false)
		specInfo.LengthEditBox:SetMaxLetters(3)
		specInfo.LengthEditBox:SetSize(40, 15)
		specInfo.LengthEditBox:SetJustifyH("CENTER")
		specInfo.LengthEditBox:SetJustifyV("CENTER")
		specInfo.LengthEditBox:SetNumber(specSettings.Length)
		specInfo.LengthEditBox:SetCursorPosition(0)
		specInfo.LengthEditBox:ClearFocus()
		specInfo.LengthEditBox:SetScript("OnEnterPressed", function(self, userInput)
			specInfo.LengthEditBox:ClearFocus()
		end)
		specInfo.LengthEditBox:SetScript("OnEscapePressed", function(self, userInput)
			specInfo.LengthEditBox:ClearFocus()
		end)
		specInfo.LengthEditBox:SetScript("OnEditFocusLost", function(self, userInput)
			local value = specInfo.LengthEditBox:GetNumber() or 0
			local minval, maxval = specInfo.Length:GetMinMaxValues()
			if (value > maxval) then
				value = maxval
				specInfo.LengthEditBox:SetNumber(value)
				specInfo.Length:SetValue(value)
			elseif (value < minval) then
				value = minval
				specInfo.LengthEditBox:SetNumber(value)
				specInfo.Length:SetValue(value)
			else
				specInfo.Length:SetValue(value)
			end
		end)
		
		specInfo.Scale = CreateFrame("Slider", "Scale" .. specID, PWROptionsPanel.Content, "OptionsSliderTemplate")
		specInfo.Scale:SetOrientation("HORIZONTAL")
		specInfo.Scale:SetPoint("LEFT", specInfo.ShowPercent, "RIGHT", 215, 0) 
		specInfo.Scale:SetSize(140, 16) 
		specInfo.Scale:SetMinMaxValues(50, 150)
		specInfo.Scale:SetValueStep(1)
		specInfo.Scale:SetObeyStepOnDrag(true)
		specInfo.Scale:SetValue(specSettings.Scale * 100.0)
		_G[specInfo.Scale:GetName() .. "Low"]:SetText("50%")
		_G[specInfo.Scale:GetName() .. "High"]:SetText("150%")
		_G[specInfo.Scale:GetName() .. "Text"]:SetText("Scale: " .. specInfo.Scale:GetValue() .. "%")
		specInfo.Scale:SetScript("OnValueChanged", function (self, value) 
			value = value
			specSettings.Scale = value / 100.0
			_G[specInfo.Scale:GetName() .. "Text"]:SetText("Scale: " .. value .. "%")
			specInfo.ScaleEditBox:SetNumber(value)
			if (GetSpecialization() == specID) then
				mainFrame:SetScale(specSettings.Scale)
				mainFrame:ClearAllPoints()
				mainFrame:SetPoint("BOTTOMLEFT", specSettings.XPos / specSettings.Scale, specSettings.YPos / specSettings.Scale)
			end
		end)
		
		specInfo.ScaleEditBox = CreateFrame("EditBox", "ScaleEditBox" .. specID, specInfo.Scale, "InputBoxTemplate")
		specInfo.ScaleEditBox:SetPoint("CENTER", 0, -15)
		specInfo.ScaleEditBox:SetNumeric(true)
		specInfo.ScaleEditBox:SetAutoFocus(false)
		specInfo.ScaleEditBox:SetMaxLetters(3)
		specInfo.ScaleEditBox:SetSize(40, 15)
		specInfo.ScaleEditBox:SetJustifyH("CENTER")
		specInfo.ScaleEditBox:SetJustifyV("CENTER")
		specInfo.ScaleEditBox:SetNumber(specSettings.Scale * 100.0)
		specInfo.ScaleEditBox:SetCursorPosition(0)
		specInfo.ScaleEditBox:ClearFocus()
		specInfo.ScaleEditBox:SetScript("OnEnterPressed", function(self, userInput)
			specInfo.ScaleEditBox:ClearFocus()
		end)
		specInfo.ScaleEditBox:SetScript("OnEscapePressed", function(self, userInput)
			specInfo.ScaleEditBox:ClearFocus()
		end)
		specInfo.ScaleEditBox:SetScript("OnEditFocusLost", function(self, userInput)
			local value = specInfo.ScaleEditBox:GetNumber() or 0
			local minval, maxval = specInfo.Scale:GetMinMaxValues()
			if (value > maxval) then
				value = maxval
				specInfo.ScaleEditBox:SetNumber(value)
				specInfo.Scale:SetValue(value)
			elseif (value < minval) then
				value = minval
				specInfo.ScaleEditBox:SetNumber(value)
				specInfo.Scale:SetValue(value)
			else
				specInfo.Scale:SetValue(value)
			end
		end)
		
		specInfo.BorderChoice = PWRCreateDropdownMenu("BorderChoice", specID, PWRBorderChoices, 100, function(menuIndex, value)
			specSettings.BorderChoice = value
			if (GetSpecialization() == specID) then
				PWRSetVisible(mainFrame.Border, specSettings.BorderChoice)
				mainFrame.Border:SetTexture(specSettings.BorderChoice)
			end
		end)
		specInfo.BorderChoice:SetPoint("BOTTOMLEFT", specInfo.IsOnlyInCombat, "BOTTOMLEFT", 20, -30)
		UIDropDownMenu_SetSelectedValue(specInfo.BorderChoice, specSettings.BorderChoice)
		
		specInfo.CurrentAlign = PWRCreateDropdownMenu("CurrentAlign", specID, PWRAlignments, 60, function(menuIndex, value)
			specSettings.CurrentAlign = value
			if (GetSpecialization() == specID) then
				PWRAlignLabel(mainFrame.Current, value, specID)
			end
		end)
		specInfo.CurrentAlign:SetPoint("LEFT", specInfo.ShowCurrent, "RIGHT", 105, 0)
		UIDropDownMenu_SetSelectedValue(specInfo.CurrentAlign, specSettings.CurrentAlign)
		PWRSetVisible(specInfo.CurrentAlign, specSettings.ShowCurrent)
		
		specInfo.PercentAlign = PWRCreateDropdownMenu("PercentAlign", specID, PWRAlignments, 60, function(menuIndex, value)
			specSettings.PercentAlign = value
			if (GetSpecialization() == specID) then
				PWRAlignLabel(mainFrame.Percent, value, specID)
			end
		end)
		specInfo.PercentAlign:SetPoint("LEFT", specInfo.ShowPercent, "RIGHT", 105, 0)
		UIDropDownMenu_SetSelectedValue(specInfo.PercentAlign, specSettings.PercentAlign)
		PWRSetVisible(specInfo.PercentAlign, specSettings.ShowPercent)
		
		specInfo.MaxAlign = PWRCreateDropdownMenu("MaxAlign", specID, PWRAlignments, 60, function(menuIndex, value)
			specSettings.MaxAlign = value
			if (GetSpecialization() == specID) then
				PWRAlignLabel(mainFrame.Max, value, specID)
			end
		end)
		specInfo.MaxAlign:SetPoint("LEFT", specInfo.ShowMax, "RIGHT", 105, 0)
		UIDropDownMenu_SetSelectedValue(specInfo.MaxAlign, specSettings.MaxAlign)
		PWRSetVisible(specInfo.MaxAlign, specSettings.ShowMax)
		
		specInfo.SkinLabel = PWROptionsPanel.Content:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
		specInfo.SkinLabel:SetText("Skin :")
		specInfo.SkinLabel:SetPoint("LEFT", specInfo.BorderChoice, "LEFT", -15, 0)
		
		PWROptionsPanel.Content:SetSize(100, height)
	end

	InterfaceOptions_AddCategory(PWROptionsPanel)
end
